-- The MATRIX v0.01 -- CyrekSoft 2000 -- Carl R. White

-- Here we have the beginnings of a text-based screensaver [or something]
-- heavily inspired by the screen displays in a film by the same name. ;-)

-- The exception here is that we're not limited to Green, or one screen
-- resolution, althoght you can have it that way if you so wish.

-- Enjoy. -- Carl :-)

include graphics.e
object junk

without warning
without type_check

function choose_from(sequence items)
    return items[rand(length(items))]
end function

constant -- Don't change these

    X = {40, 80},
    Y = {25, 28, 43, 50},

    DARK  = {
	RED,        GREEN,          BLUE,
	BROWN,      CYAN,           MAGENTA,
	GRAY,       WHITE
    }, -- BLACK

    LIGHT = {
	BRIGHT_RED, BRIGHT_GREEN,   BRIGHT_BLUE,
	YELLOW,     BRIGHT_CYAN,    BRIGHT_MAGENTA,
	WHITE,      BRIGHT_WHITE
    }  -- GRAY

constant -- change these!

-- Use these for total unpredictability...
--
--        Cols = choose_from(X),
--        Rows = choose_from(Y),
--      Colour = choose_from(DARK),
--     BColour = LIGHT[find(Colour, DARK)]

       Cols = choose_from(X),--80
       Rows = choose_from(Y),--25
     Colour = choose_from(DARK),--GREEN,
    BColour = LIGHT[find(Colour, DARK)]--BRIGHT_GREEN


-- Initialise --

junk = graphics_mode(Cols/20-1) -- Works for 80 & 40 *only*!
junk = text_rows(Rows)
wrap(0)
cursor(NO_CURSOR)
text_color(Colour)

global sequence screen
screen = repeat(repeat(' ', Rows), Cols)

-- What we can do --

procedure draw(integer col)
    -- Draw a column, including [usually-] leading bright char
    integer char
    for row = 1 to Rows do
	char = screen[col][row]
	position(row, col)
	if char < 0 then
	    char = -char
	    screen[col][row] = char
	    text_color(BColour)
	    puts(1, char)
	    text_color(Colour)
	else
	    puts(1, char)
	end if
    end for
end procedure

procedure shift_down(integer col)
    -- Drop column a few rows
    integer r
    r = rand(Rows/5)
    screen[col] = repeat(' ', r) & screen[col][1..Rows-r]
end procedure

procedure shift_up(integer col)
    -- Scroll colun up a few rows
    integer r
    r = rand(Rows/4)
    screen[col] = screen[col][r+1..Rows] & repeat(' ', r)
end procedure

procedure delete(integer col)
    -- Blank a whole row
    screen[col] = repeat(' ', Rows)
end procedure

function find_last_char(sequence s)
    -- Finds last non-space character
    for row = Rows to 1 by -1 do
	if s[row] != ' ' then
	    return row
	end if
    end for
    return 0
end function

procedure char_bright(integer col)
    -- Make a non-leading char glow
    integer row, r
    r = find_last_char(screen[col])
    if not r then return end if
    row = rand(r)
    while screen[col][row] = ' ' do
	row = rand(r)
    end while
    screen[col][row] = -screen[col][row]
end procedure

procedure add_to(integer col)
    -- Add a random char to a column, making it creep downwards
    integer row
    row = find_last_char(screen[col]) + 1
    if row > Rows then
	shift_up(col)
	add_to(col)
	return
    end if
    screen[col][row] = -32-rand(222) -- 33..254
end procedure

-- procedure @Main()

integer column, action

while get_key() = -1 do
    column = rand(Cols)
    action = rand(100)

    if action < 3 then      --   2% --
	shift_up(column)

    elsif action < 5 then   --   2% --
	shift_down(column)

    elsif action < 6 then   --   1% --
	delete(column)

    elsif action < 7 then   --   1% --
	char_bright(column)

    else                    --  94% --
	add_to(column)

    end if                  -- ---- --

    draw(column)            -- 100% --
end while

-- Debrief --

cursor(THICK_UNDERLINE_CURSOR)
junk = graphics_mode(-1)

